module multiply
  
contains

  subroutine multiply_add(A, B, C, M)
    implicit none
    integer :: M
    double precision, dimension(M * M) :: A, B, C

    integer :: i, j, k
    double precision :: tmp1, tmp2
    integer :: iM, kM

    !integer :: rank
    !call MPI_Comm_rank(MPI_COMM_WORLD, rank, err)

    ! The compiler optimizes this pretty well, at least better than
    ! any manual attempt at improving locality
    do i=0, M - 1
       do j=0, M - 1
          do k=0, M - 1
             C(1 + i * M + j) = C(1 + i * M + j) + &
                  A(1 + i * M + k) * B(1 + k * M + j)
          enddo
       enddo
    enddo
    
  end subroutine multiply_add


end module multiply
